/** @file audiod.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef AUDIOD_CMDLINE_H
#define AUDIOD_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef AUDIOD_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define AUDIOD_CMDLINE_PARSER_PACKAGE "para_audiod"
#endif

#ifndef AUDIOD_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define AUDIOD_CMDLINE_PARSER_VERSION "0.3.4"
#endif

enum enum_color { color_arg_yes = 0 , color_arg_no, color_arg_auto };

/** @brief Where the command line options are stored */
struct audiod_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * loglevel_arg;	/**< @brief set loglevel (default='warning').  */
  char * loglevel_orig;	/**< @brief set loglevel original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel help description.  */
  enum enum_color color_arg;	/**< @brief activate color output (default='auto').  */
  char * color_orig;	/**< @brief activate color output original value given at command line.  */
  const char *color_help; /**< @brief activate color output help description.  */
  char ** log_color_arg;	/**< @brief select a color for one type of log message.  */
  char ** log_color_orig;	/**< @brief select a color for one type of log message original value given at command line.  */
  unsigned int log_color_min; /**< @brief select a color for one type of log message's minimum occurreces */
  unsigned int log_color_max; /**< @brief select a color for one type of log message's maximum occurreces */
  const char *log_color_help; /**< @brief select a color for one type of log message help description.  */
  char * config_file_arg;	/**< @brief (default='~/.paraslash/audiod.conf').  */
  char * config_file_orig;	/**< @brief (default='~/.paraslash/audiod.conf') original value given at command line.  */
  const char *config_file_help; /**< @brief (default='~/.paraslash/audiod.conf') help description.  */
  char * logfile_arg;	/**< @brief where to write log output.  */
  char * logfile_orig;	/**< @brief where to write log output original value given at command line.  */
  const char *logfile_help; /**< @brief where to write log output help description.  */
  int daemon_flag;	/**< @brief run as background daemon (default=off).  */
  const char *daemon_help; /**< @brief run as background daemon help description.  */
  char * user_arg;	/**< @brief run as the given user.  */
  char * user_orig;	/**< @brief run as the given user original value given at command line.  */
  const char *user_help; /**< @brief run as the given user help description.  */
  char * group_arg;	/**< @brief set group id.  */
  char * group_orig;	/**< @brief set group id original value given at command line.  */
  const char *group_help; /**< @brief set group id help description.  */
  int force_flag;	/**< @brief force startup (default=off).  */
  const char *force_help; /**< @brief force startup help description.  */
  char * mode_arg;	/**< @brief startup mode (default='on').  */
  char * mode_orig;	/**< @brief startup mode original value given at command line.  */
  const char *mode_help; /**< @brief startup mode help description.  */
  char * socket_arg;	/**< @brief well-known socket.  */
  char * socket_orig;	/**< @brief well-known socket original value given at command line.  */
  const char *socket_help; /**< @brief well-known socket help description.  */
  int* user_allow_arg;	/**< @brief allow this uid (default='-1').  */
  char ** user_allow_orig;	/**< @brief allow this uid original value given at command line.  */
  unsigned int user_allow_min; /**< @brief allow this uid's minimum occurreces */
  unsigned int user_allow_max; /**< @brief allow this uid's maximum occurreces */
  const char *user_allow_help; /**< @brief allow this uid help description.  */
  int clock_diff_count_arg;	/**< @brief sync clock on startup (default='0').  */
  char * clock_diff_count_orig;	/**< @brief sync clock on startup original value given at command line.  */
  const char *clock_diff_count_help; /**< @brief sync clock on startup help description.  */
  char ** receiver_arg;	/**< @brief select receiver (default='http').  */
  char ** receiver_orig;	/**< @brief select receiver original value given at command line.  */
  unsigned int receiver_min; /**< @brief select receiver's minimum occurreces */
  unsigned int receiver_max; /**< @brief select receiver's maximum occurreces */
  const char *receiver_help; /**< @brief select receiver help description.  */
  int no_default_filters_flag;	/**< @brief Configure filters manually (default=off).  */
  const char *no_default_filters_help; /**< @brief Configure filters manually help description.  */
  char ** filter_arg;	/**< @brief Use non-default filters.  */
  char ** filter_orig;	/**< @brief Use non-default filters original value given at command line.  */
  unsigned int filter_min; /**< @brief Use non-default filters's minimum occurreces */
  unsigned int filter_max; /**< @brief Use non-default filters's maximum occurreces */
  const char *filter_help; /**< @brief Use non-default filters help description.  */
  char ** writer_arg;	/**< @brief Specify stream writer..  */
  char ** writer_orig;	/**< @brief Specify stream writer. original value given at command line.  */
  unsigned int writer_min; /**< @brief Specify stream writer.'s minimum occurreces */
  unsigned int writer_max; /**< @brief Specify stream writer.'s maximum occurreces */
  const char *writer_help; /**< @brief Specify stream writer. help description.  */
  int stream_delay_arg;	/**< @brief time for client sync (default='200').  */
  char * stream_delay_orig;	/**< @brief time for client sync original value given at command line.  */
  const char *stream_delay_help; /**< @brief time for client sync help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  unsigned int color_given ;	/**< @brief Whether color was given.  */
  unsigned int log_color_given ;	/**< @brief Whether log_color was given.  */
  unsigned int config_file_given ;	/**< @brief Whether config_file was given.  */
  unsigned int logfile_given ;	/**< @brief Whether logfile was given.  */
  unsigned int daemon_given ;	/**< @brief Whether daemon was given.  */
  unsigned int user_given ;	/**< @brief Whether user was given.  */
  unsigned int group_given ;	/**< @brief Whether group was given.  */
  unsigned int force_given ;	/**< @brief Whether force was given.  */
  unsigned int mode_given ;	/**< @brief Whether mode was given.  */
  unsigned int socket_given ;	/**< @brief Whether socket was given.  */
  unsigned int user_allow_given ;	/**< @brief Whether user_allow was given.  */
  unsigned int clock_diff_count_given ;	/**< @brief Whether clock_diff_count was given.  */
  unsigned int receiver_given ;	/**< @brief Whether receiver was given.  */
  unsigned int no_default_filters_given ;	/**< @brief Whether no_default_filters was given.  */
  unsigned int filter_given ;	/**< @brief Whether filter was given.  */
  unsigned int writer_given ;	/**< @brief Whether writer was given.  */
  unsigned int stream_delay_given ;	/**< @brief Whether stream_delay was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct audiod_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure audiod_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure audiod_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *audiod_args_info_purpose;
/** @brief the usage string of the program */
extern const char *audiod_args_info_usage;
/** @brief all the lines making the help output */
extern const char *audiod_args_info_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *audiod_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser (int argc, char * const *argv,
  struct audiod_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use audiod_cmdline_parser_ext() instead
 */
int audiod_cmdline_parser2 (int argc, char * const *argv,
  struct audiod_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser_ext (int argc, char * const *argv,
  struct audiod_args_info *args_info,
  struct audiod_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser_dump(FILE *outfile,
  struct audiod_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser_file_save(const char *filename,
  struct audiod_args_info *args_info);

/**
 * Print the help
 */
void audiod_cmdline_parser_print_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void audiod_cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void audiod_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a audiod_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void audiod_cmdline_parser_params_init(struct audiod_cmdline_parser_params *params);

/**
 * Allocates dynamically a audiod_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized audiod_cmdline_parser_params structure
 */
struct audiod_cmdline_parser_params *audiod_cmdline_parser_params_create(void);

/**
 * Initializes the passed audiod_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void audiod_cmdline_parser_init (struct audiod_args_info *args_info);
/**
 * Deallocates the string fields of the audiod_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void audiod_cmdline_parser_free (struct audiod_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use audiod_cmdline_parser_config_file() instead
 */
int audiod_cmdline_parser_configfile (char * const filename,
  struct audiod_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser_config_file (char * const filename,
  struct audiod_args_info *args_info,
  struct audiod_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int audiod_cmdline_parser_required (struct audiod_args_info *args_info,
  const char *prog_name);

extern char *audiod_cmdline_parser_loglevel_values[] ;	/**< @brief Possible values for loglevel.  */
extern char *audiod_cmdline_parser_color_values[] ;	/**< @brief Possible values for color.  */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* AUDIOD_CMDLINE_H */
